
public class TreeDriver {

	private static BinarySearchTree<Person<Integer>, Integer> bst = new BinarySearchTree<Person<Integer>, Integer>();

	
	public static void ShowTree() {
		System.out.println("In Order");
		TreeElementIterator<Person<Integer>, Integer> iter = bst.iterator();
		
		while (iter.hasNext()) {
			System.out.println(iter.next());
		}
		
		System.out.println("Pre Order");
		iter = bst.iterator();
		iter.setPreOrder();
		
		while (iter.hasNext()) {
			System.out.println(iter.next());
		}
		
		System.out.println("Post Order");
		iter = bst.iterator();
		iter.setPostOrder();
		
		while (iter.hasNext()) {
			System.out.println(iter.next());
		}
	}
	
	
	public static void main(String[] args) {
		Integer[] keys = {15, 10, 25, 5, 12, 20, 30};
		
		System.out.println("\n\n-------------------------------------------------------------------------");
		System.out.println("Inserting 7 elements into Binary Search Tree");
		System.out.println("-------------------------------------------------------------------------");
		for ( int i = 0 ; i < keys.length ; i++ ) {
			Person<Integer> p = new Person<Integer>(keys[i]);
			bst.insert(p);
		}

		TreeDriver.ShowTree();
		System.out.println("-------------------------------------------------------------------------");
		
		System.out.println("\n\n-------------------------------------------------------------------------");
		System.out.println("Deleting 5, a leaf node in left subtree");
		System.out.println("-------------------------------------------------------------------------");
		// delete a leaf node
		bst.delete(5);

		TreeDriver.ShowTree();
		System.out.println("-------------------------------------------------------------------------");
		
		System.out.println("\n\n-------------------------------------------------------------------------");
		System.out.println("Deleting 30, a leaf node in right subtree");
		System.out.println("-------------------------------------------------------------------------");
		// delete a leaf node
		bst.delete(30);

		TreeDriver.ShowTree();
		System.out.println("-------------------------------------------------------------------------");
		
		System.out.println("\n\n-------------------------------------------------------------------------");
		System.out.println("Deleting 10, a node with only a right child");
		System.out.println("-------------------------------------------------------------------------");
		// delete a node with only a right child
		bst.delete(10);

		TreeDriver.ShowTree();
		System.out.println("-------------------------------------------------------------------------");
		
		System.out.println("\n\n-------------------------------------------------------------------------");
		System.out.println("Deleting 25, a node with only a left child");
		System.out.println("-------------------------------------------------------------------------");
		// delete a node with only a left child
		bst.delete(25);

		TreeDriver.ShowTree();
		System.out.println("-------------------------------------------------------------------------");
		
		System.out.println("\n\n-------------------------------------------------------------------------");
		System.out.println("Deleting 15, a root node with 2 children");
		System.out.println("-------------------------------------------------------------------------");
		// delete a root node with 2 children
		bst.delete(15);

		TreeDriver.ShowTree();
		System.out.println("-------------------------------------------------------------------------");
	}

}
